/* This code is copyrighted (c) 1997 by Marshall Ramsey */
import java.io.*;
import java.awt.*;
import java.awt.event.*;

public class FileChooser extends Dialog implements ActionListener {
  boolean okPressed;
  Button ok;
  Button cancel;
  List lessons;

  public FileChooser(Frame frame, String dir, boolean modal) {
    super(frame, modal);
    okPressed = false;
    setLayout(new GridBagLayout());
    ok = new Button("OK");
    cancel = new Button("Cancel");
    lessons = new List(10, true);

    File file = new File(dir);
    String[] dirEntries = file.list();
    for (int i=0; i<dirEntries.length; i++)
      lessons.add(dirEntries[i]);

    Tools.constrain(this, lessons, 0, 0, 2, 10,
		    GridBagConstraints.BOTH, GridBagConstraints.CENTER,
		    1.0, 1.0, 2, 2, 2, 2);
    Tools.constrain(this, ok, 0, 10, 1, 2,
		    GridBagConstraints.BOTH, GridBagConstraints.CENTER,
		    1.0, 0.0, 2, 2, 2, 2);
    Tools.constrain(this, cancel, 1, 10, 1, 2,
		    GridBagConstraints.BOTH, GridBagConstraints.CENTER,
		    1.0, 0.0, 2, 2, 2, 2);
    pack();
    ok.addActionListener(this);
    cancel.addActionListener(this);
  }

  public synchronized void setVisible(boolean visible) {
    if (visible) {
      Rectangle bounds = getParent().getBounds();
      Rectangle abounds = getBounds();

      setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
	   bounds.y + (bounds.height - abounds.height)/2);
      setResizable(false);
      super.setVisible(true);
      setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
	   bounds.y + (bounds.height - abounds.height)/2);
      requestFocus();
    }
    else
      super.setVisible(visible);
  }

  public String[] getFiles() {
    if (okPressed) {
      String[] files = lessons.getSelectedItems();
      return files;
    }
    else
      return null;
  }

  public void actionPerformed(ActionEvent e) {
    if (e.getSource() == ok)
     OKpressed();
    if (e.getSource() == cancel)
     cancelPressed();
  }

  private void OKpressed() {
    okPressed = true;
    dispose();
  }

  private void cancelPressed() {
    okPressed = false;
    dispose();
  }
}
