/* This code is copyrighted (c) 1997 by Marshall Ramsey */
import java.applet.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;

public class LessonChooser extends Dialog implements ActionListener {
  Applet app;
  boolean cancelPressed;
  Button ok;
  Button cancel;
  List lessons;

  public LessonChooser(Frame frame, ActionListener al, Applet app,
		       boolean modal, boolean multiFile) {
    super(frame, modal);
    this.app = app;
    cancelPressed = false;
    setLayout(new GridBagLayout());
    ok = new Button("OK");
    cancel = new Button("Cancel");
    lessons = new List(10, multiFile);
    int i = 0;
    String stub = new String("file");
    String param = app.getParameter(stub + Integer.toString(i));
    while(param != null) {
      lessons.add(param);
      i++;
      param = app.getParameter(stub + Integer.toString(i));
    }
    Tools.constrain(this, lessons, 0, 0, 2, 10,
		    GridBagConstraints.BOTH, GridBagConstraints.CENTER,
		    1.0, 1.0, 2, 2, 2, 2);
    Tools.constrain(this, ok, 0, 10, 1, 2,
		    GridBagConstraints.BOTH, GridBagConstraints.CENTER,
		    1.0, 0.0, 2, 2, 2, 2);
    Tools.constrain(this, cancel, 1, 10, 1, 2,
		    GridBagConstraints.BOTH, GridBagConstraints.CENTER,
		    1.0, 0.0, 2, 2, 2, 2);
    pack();
    ok.addActionListener(this);
    ok.addActionListener(al);
    cancel.addActionListener(this);
  }

  public synchronized void setVisible(boolean visible) {
    if (visible) {
      Rectangle bounds = getParent().getBounds();
      Rectangle abounds = getBounds();

      setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
	   bounds.y + (bounds.height - abounds.height)/2);
      setResizable(false);
      super.setVisible(true);
      setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
	   bounds.y + (bounds.height - abounds.height)/2);
      requestFocus();
    }
    else
      super.setVisible(visible);
  }

  public URL[] getURLs() {
    try {
      if (!cancelPressed) {
	URL base = app.getCodeBase();
	String host = base.getHost();
	String protocol = base.getProtocol();
	int port =base.getPort();
	String origFile = base.getFile();
	String[] files = lessons.getSelectedItems();
	URL[] urls = new URL[files.length];
	for (int i=0; i<files.length; i++) {
	  String filePath = new String(origFile + "cards/" + files[i]);
	  urls[i] = new URL(protocol, host, port, filePath);
	}
	return urls;
      }
      else
	return null;
    }
    catch(MalformedURLException mfue) {
      Tools.perr(mfue);
      return null;
    }
  }

  public void actionPerformed(ActionEvent e) {
    if (e.getSource() == ok)
     OKpressed();
    if (e.getSource() == cancel)
     cancelPressed();
  }

  private void OKpressed() {
    cancelPressed = false;
    dispose();
  }

  private void cancelPressed() {
    cancelPressed = true;
    dispose();
  }
}
