/* This code is copyrighted (c) 1997 by Marshall Ramsey */
import java.util.*;

public class LessonItem {
  static final boolean debug = false;
  //  String meaning;
  //  String yomi;
  String[] meaning;
  String[] yomi;
  String kanji;
  boolean valid;

  /*
  public LessonItem(String buf) {
    valid = false;
    kanji = null;
    yomi = null;
    meaning = null;
    StringTokenizer strTok = new StringTokenizer(buf, " ");
    try {
      if (readKanji(strTok)) {
	if (hasYomi(buf))
	  readYomi(strTok);
	else
	  yomi = new String("");
	if (readMeaning(strTok))
	  valid = true;
      }
    }
    catch (NoSuchElementException nsee) {
      valid = false;
    }
  }
  */

  public LessonItem(String buf) {
    valid = false;
    kanji = null;
    yomi = null;
    meaning = null;
    StringTokenizer strTok = new StringTokenizer(buf, " ");
    try {
      if (readKanji(strTok)) {
	if (hasYomi(buf))
	  readYomi(strTok);
	else {
	  yomi = new String[1];
	  yomi[0] = new String("");
	}
	if (readMeaning(strTok))
	  valid = true;
      }
    }
    catch (NoSuchElementException nsee) {
      valid = false;
    }
  }

  private boolean hasYomi(String buf) {
    int i = buf.indexOf("[");
    int j = buf.indexOf("]");
    if (i != -1 && j != -1 && j != i+1)
      return true;
    else
      return false;
  }

  private boolean readKanji(StringTokenizer strTok) throws NoSuchElementException {
    kanji = strTok.nextToken();
    return (kanji != null);
  }

  private boolean readYomi(StringTokenizer strTok) throws NoSuchElementException {
    strTok.nextToken("[]"); // skip space and first bracket
    StringTokenizer yomiTok = new StringTokenizer(strTok.nextToken(), "/");
    if (yomiTok.hasMoreTokens()) {
      int count = yomiTok.countTokens();
      yomi = new String[count];
      for(int i=0; i<count; i++) {
	yomi[i] = yomiTok.nextToken(); // get reading
      }
    }
    return (yomi != null);
  }

  private boolean readMeaning(StringTokenizer strTok) throws NoSuchElementException {
    strTok.nextToken("/" + (char)13); // skip space and first slash
    if (strTok.hasMoreTokens()) {
      int count = strTok.countTokens();
      meaning = new String[count];
      for(int i=0; i<count; i++) {
	meaning[i] = strTok.nextToken(); // get reading
      }
    }
    return (meaning != null);
  }

  public boolean isValid() { return valid; }
  
  public String getKanji() { return kanji; }

  public String getYomi() {
    String string = "";
    for (int i=0; i<yomi.length-1; i++)
      string += yomi[i] + "; ";
    string += yomi[yomi.length-1];
    return string;
  }

  public String getMeaning() {
    String string = "";
    for (int i=0; i<meaning.length-1; i++)
      string += meaning[i] + "; ";
    string += meaning[meaning.length-1];
    return string;
  }

  public boolean meaningRight(String guess) {
    for (int i=0; i<meaning.length; i++) {
      if (guess.equals(meaning[i]))
	return true;
    }
    return false;
  }

  public boolean yomiRight(String guess) {
    if (yomi != null) {
      for (int i=0; i<yomi.length; i++) {
	if (guess.equals(yomi[i]))
	  return true;
      }
    }
    else
      return true; // if no yomi then any answer is considered correct
    return false;
  }

  /*
  private boolean readYomi(StringTokenizer strTok) throws NoSuchElementException {
    strTok.nextToken("[]"); // skip space and first bracket
    StringTokenizer yomiTok = new StringTokenizer(strTok.nextToken(), "/");
    yomi = new String();
    while(yomiTok.hasMoreTokens()) {
      yomi += yomiTok.nextToken(); // get reading
      if (yomiTok.hasMoreTokens())
	yomi += "; ";
    }
    return (yomi != null);
  }

  private boolean readMeaning(StringTokenizer strTok) throws NoSuchElementException {
    strTok.nextToken("/" + (char)13); // skip space and first slash
    meaning = new String();
    while(strTok.hasMoreTokens()) {
      String temp = strTok.nextToken();
      meaning += temp; // get meaning
      if (strTok.hasMoreTokens())
	meaning += "; ";
    }
    return (meaning != null);
  }

  public boolean isValid() { return valid; }
  
  public String getKanji() { return kanji; }

  public String getYomi() { return yomi; }

  public String getMeaning() { return meaning; }

*/
}
