/* This code is copyrighted (c) 1997 by Marshall Ramsey */

import java.awt.*;
import java.awt.event.*;

public class Scribble extends BorderedPanel implements ActionListener, ItemListener {
  private Button clear_button;
  private Choice color_choices;
  private ScribbleCanvasWithText scribbleCanvas;

  public Scribble() {

    // Create a button and add it to the applet.
    // Also, set the button's colors
    clear_button = new Button("Clear");
    clear_button.setForeground(Color.black);
    clear_button.setBackground(Color.lightGray);
    clear_button.addActionListener(this);

    // Create a menu of colors and add it to the applet.
    // Also set the menus's colors and add a label.
    color_choices = new Choice();
    color_choices.addItem("black");
    color_choices.addItem("red");
    color_choices.addItem("yellow");
    color_choices.addItem("green");
    color_choices.addItem("blue");
    color_choices.setForeground(Color.black);
    color_choices.setBackground(Color.lightGray);
    color_choices.addItemListener(this);

    scribbleCanvas = new ScribbleCanvasWithText();

    setLayout(new GridBagLayout());
    Tools.constrain(this, clear_button, 0, 1, 1, 1,
		    GridBagConstraints.BOTH, GridBagConstraints.CENTER,
		    0.333, 0.0, 0, 5, 0, 0);
    Tools.constrain(this, new Label("Color: ", Label.RIGHT), 1, 1, 1, 1,
		    GridBagConstraints.BOTH, GridBagConstraints.EAST,
		    0.333, 0.0);
    Tools.constrain(this, color_choices, 2, 1, 1, 1,
		    GridBagConstraints.BOTH, GridBagConstraints.CENTER,
		    0.333, 0.0, 0, 0, 0, 5);
    Tools.constrain(this, scribbleCanvas, 0, 2, 3, 5,
		    GridBagConstraints.BOTH, GridBagConstraints.CENTER,
		    1.0, 1.0, 5, 5, 5, 5);
  }
    
  public Scribble(String title) {
    this();
    Tools.constrain(this, new Label(title, Label.LEFT), 0, 0, 3, 1,
		    GridBagConstraints.BOTH, GridBagConstraints.WEST,
		    1.0, 0.0, 5, 5, 0, 5);
  }

  public void actionPerformed(ActionEvent e) {
    Object target = e.getSource();
    if (target == clear_button)
      clear();
  }

  public void itemStateChanged(ItemEvent e) {
    // if a color was chosen, handle that
    Object target = e.getSource();
    if (target == color_choices) {
      String colorname = (String) e.getItem();
      if (colorname.equals("black"))
	scribbleCanvas.setForeground(Color.black);
      else if (colorname.equals("red"))
	scribbleCanvas.setForeground(Color.red);
      else if (colorname.equals("yellow"))
	scribbleCanvas.setForeground(Color.yellow);
      else if (colorname.equals("green"))
	scribbleCanvas.setForeground(Color.green);
      else if (colorname.equals("blue"))
	scribbleCanvas.setForeground(Color.blue);
    }
  }

  public void clear() { scribbleCanvas.clear(); }

  public void setText(String text) { scribbleCanvas.setText(text); }

}
