import java.awt.*;

public class ScribbleCanvasWithText extends ScribbleCanvas {
  String text;

  public ScribbleCanvasWithText() { super(); text = null; }

  public ScribbleCanvasWithText(String text) {
    super();
    this.text = text;
  }

  public void setText(String text) { this.text = text; repaint(); }

  public void paint(Graphics g) {
    if (g != null) {
      if (isShowing() && text != null && !text.equals("")) {
	//draw string
	Dimension d = getSize();
	Font f = new Font("sansserif", Font.PLAIN, 20);
	FontMetrics fm = getFontMetrics(f);
	int h = fm.getHeight();
	int w = fm.stringWidth(text);
	int x = d.width/2 - w/2;
        int y = d.height/2 + h/3;
	g.setColor(Color.blue);
	g.setFont(f);
	g.drawString(text, x, y);
      }
    }
  }

  public void clear() {
    text = null;
    super.clear();
  }
}
