/* This code is copyrighted (c) 1997 by Marshall Ramsey */
import java.awt.*;

public class TextCanvas extends Canvas {
  public static final int CENTER=0;
  public static final int LEFT=1;
  public static final int RIGHT=1;
  public static final int DEFAULT_MAXSIZE = 120;
  protected int justify;
  protected String text;
  protected boolean showing;

  public TextCanvas() {
    text = new String("");
    this.justify = LEFT;
    showing = true;
  }

  public TextCanvas(int justify) {
    text = new String("");
    this.justify = justify;
    showing = true;
  }

  public void setText(String text) { this.text = text; repaint(); }

  public String getText() { return text; }

  public void setVisible(boolean visible) {
    showing = visible; repaint();
  }

  public void setMaxSize(int maxSize) {  } // default: do nothing

  // draw a border around drawing area
  public void paint(Graphics g) {
    Dimension d = getSize();

    //draw border
    g.setColor(Color.gray);
    g.drawLine(0, 0, d.width-1, 0);
    g.drawLine(0, 1, 0, d.height-1);
    g.setColor(Color.black);
    g.drawLine(1, 1, d.width-2, 1);
    g.drawLine(1, 2, 1, d.height-2);
    g.setColor(Color.lightGray);
    g.drawLine(d.width-2, 1, d.width-2, d.height-2);
    g.drawLine(1, d.height-2, d.width-2, d.height-2);
    g.setColor(Color.white);
    g.drawLine(d.width-1, 0, d.width-1, d.height-1);
    g.drawLine(0, d.height-1, d.width-1, d.height-1);
  }
}


