/* This code is copyrighted (c) 1997 by Marshall Ramsey */
import java.io.*;
import java.awt.*;

//=============================================================
class Tools {

  public static final boolean debug = true;

  static void assert(boolean v){
    if(!v && debug){
      System.err.println("Assert Error!");
    }
  }

  static void perr(Exception e){
    System.err.println("Exception caught!\n" + e);
    e.printStackTrace(System.err);
    System.gc();
  }

  static boolean interfaces(String klass, String iface)
    throws ClassNotFoundException {
      Class c1 = Class.forName(klass);
      Class ifaces[] = c1.getInterfaces();
      for (int i=0; i<ifaces.length; i++)
	if (ifaces[i].getName().equals(iface))
	  return true;

      return false;
  }

  static String readString(DataInputStream in) throws IOException {
    int length = in.readInt();
    char buff[] = new char[length];
    for (int i=0; i<length; i++)
      buff[i] = in.readChar();
    return new String(buff);
  }

  static void writeString(String string, DataOutputStream out)
    throws IOException {
      out.writeInt(string.length());
      out.writeChars(string);
  }

  static Class readClass(DataInputStream in) throws IOException {
    try {
      return Class.forName(Tools.readString(in));
    }
    catch(ClassNotFoundException e) {
      perr(e);
      return null;
    }
  }

  static void writeClass(Class klass, DataOutputStream out)
    throws IOException {
      String name = klass.getName();
      Tools.writeString(name, out);
  }

  public static void constrain(Container container, Component component,
		       int grid_x, int grid_y, int grid_width, int grid_height,
			int fill, int anchor, double weight_x, double weight_y,
			int top, int left, int bottom, int right) {
    GridBagConstraints c = new GridBagConstraints();
    c.gridx = grid_x; c.gridy = grid_y;
    c.gridwidth = grid_width; c.gridheight = grid_height;
    c.fill = fill; c.anchor = anchor;
    c.weightx = weight_x; c.weighty = weight_y;
    if (top+bottom+left+right > 0)
      c.insets = new Insets(top,left,bottom,right);
    ((GridBagLayout)container.getLayout()).setConstraints(component,c);
    container.add(component);
  }

  public static void constrain(Container container, Component component,
			int grid_x,int grid_y,int grid_width,int grid_height) {
    constrain(container, component, grid_x, grid_y, grid_width, grid_height,
	      GridBagConstraints.NONE, GridBagConstraints.NORTHWEST,
	      0.0, 0.0, 0, 0, 0, 0);
  }

  public static void constrain(Container container, Component component,
			int grid_x,int grid_y,int grid_width,int grid_height,
			       int fill, int anchor) {
    constrain(container, component, grid_x, grid_y, grid_width, grid_height,
	      fill, anchor, 0.0, 0.0, 0, 0, 0, 0);
  }

  public static void constrain(Container container, Component component,
			int grid_x,int grid_y,int grid_width,int grid_height,
			       int fill,int anchor,double weight_x,double weight_y) {
    constrain(container, component, grid_x, grid_y, grid_width, grid_height,
	      fill, anchor, weight_x, weight_y, 0, 0, 0, 0);
  }

  public static void sleep() {
    /*
    try {
      Thread.sleep(3);
    } catch (InterruptedException e) {
        perr(e);
    }
    */
    Thread.yield();
  }
};

